#####Exerccio IV                                   Lus Coelho

########funo compete, elaborada para estimar populaes competidoras e gerar grficos de espao da fase segundo o modelo de Lotka-Volterra########
compete<-function (no1, no2, tmax, r1, r2, K1, K2, alfa, beta)
{
   resulta=matrix(0, ncol=3, nrow=tmax)
   resulta[,1]<-0:(tmax-1)
   resulta[1,2]<-no1
   resulta[1,3]<-no2
   for(t in 2:tmax)
  {
      nsp1=resulta[(t-1),2]
      nsp2=resulta[(t-1),3]
      resulta[t,2]=nsp1 + r1*nsp1*((K1-nsp1-alfa*nsp2)/K1)
      resulta[t,3]=nsp2 + r2*nsp2*((K2-nsp2-beta*nsp1)/K2)
      if (resulta[t,2]<1)
      {
          resulta[t,2]=0
      }	
       if (resulta[t,3]<1)
      {
          resulta[t,3]=0
      }
   }
   par(mfrow=c(1,2))
   plot(resulta[,1],resulta[,2],ylim=c(0,max(na.omit(resulta[,2:3]))),type="l",lty=1,xlab="tempo (t)", ylab="tamanho das populaes (N1,N2)")
   lines(resulta[,1],resulta[,3],lty=2)
   plot(resulta[,2],resulta[,3],type="l",col="red",xlab="N1",ylab="N2",ylim=c(0,max(c(na.omit(resulta[,3]),K1/alfa,K2))),xlim=c(0,max(c(na.omit(resulta[,2]),K2/beta,K1))))
   segments(0,K1/alfa,K1,0,lty=1)
   segments(0,K2,K2/beta,0,lty=2)
   return(resulta)
}

############################################################################################################
### 1 teste da funo com os parmetros r1=0.05, r2=0.03, K1=80, K2=50, alfa=1.2, beta=0.5; considerando tmax=50, no1=10 e no2=10
#### utilizando a seguinte linha de comando
compete(r1=0.05, r2=0.03, K1=80, K2=50, alfa=1.2, beta=0.5,tmax=50,no1=10,no2=10)


#################################################################################################

##### 2.rodar a funo com parmetros que gerem os quatro cenrios possveis. 

#####2.1 espcie 1 vence a competio:
compete(no1=40,no2=10,tmax=400,r1=0.05,r2=0.03,K1=50,K2=80,alfa=0.5,beta=2)
compete(no1=60,no2=10,tmax=400,r1=0.05,r2=0.03,K1=50,K2=80,alfa=0.5,beta=2)
compete(no1=10,no2=10,tmax=1500,r1=0.05,r2=0.03,K1=50,K2=80,alfa=0.5,beta=1.7)


#####Espcie 2 vence a competio:
compete(no1=10,no2=10,tmax=500,r1=0.05,r2=0.03,K1=50,K2=80,alfa=0.8,beta=1.2)
compete(no1=55,no2=10,tmax=500,r1=0.05,r2=0.03,K1=50,K2=80,alfa=0.8,beta=1.2)
compete(no1=75,no2=10,tmax=500,r1=0.05,r2=0.03,K1=50,K2=80,alfa=0.8,beta=1.2)
trao contnuo=N1 e trao pontilhado =N2

########Coexistncia estvel
compete(no1=10,no2=10,tmax=1300,r1=0.05,r2=0.03,K1=50,K2=80,alfa=0.5,beta=1.1)
compete(no1=60,no2=10,tmax=1300,r1=0.05,r2=0.03,K1=50,K2=80,alfa=0.5,beta=1.1)
compete(no1=80,no2=10,tmax=1300,r1=0.05,r2=0.03,K1=50,K2=80,alfa=0.5,beta=1.1)
compete(no1=5,no2=80,tmax=1300,r1=0.05,r2=0.03,K1=50,K2=80,alfa=0.5,beta=1.1)



#########Equilbrio instvel
compete(no1=10,no2=10,tmax=1300,r1=0.05,r2=0.03,K1=50,K2=80,alfa=0.8,beta=1.75)
compete(no1=60,no2=10,tmax=1300,r1=0.05,r2=0.03,K1=50,K2=80,alfa=0.8,beta=1.75)
compete(no1=41,no2=10,tmax=1300,r1=0.05,r2=0.03,K1=50,K2=80,alfa=0.8,beta=1.75)
compete(no1=20,no2=60,tmax=1300,r1=0.05,r2=0.03,K1=50,K2=80,alfa=0.8,beta=1.75)
compete(no1=10,no2=10,tmax=900,r1=0.05,r2=0.03,K1=50,K2=80,alfa=0.8,beta=1.9)
